####################################################################################
# some worked out functionals
####################################################################################

## to be included in the next release of distrEx (v1.7)

### intentionally mask var in order to have an additional ... argument
var<-function(x,y = NULL,na.rm = FALSE,use,...){stats::var(x,y,na.rm,use)}

####################################################################################
#registration of generics
####################################################################################
if(!isGeneric("var")){ 
    setGeneric("var", function(x,y,na.rm,use,...) standardGeneric("var"))
}

if(!isGeneric("sd")){ 
    setGeneric("sd", function(x,na.rm) standardGeneric("sd"))
}
if(!isGeneric("median")){ 
    setGeneric("median", function(x,na.rm) standardGeneric("median"))
}

if(!isGeneric("IQR")){ 
    setGeneric("IQR", function(x,na.rm) standardGeneric("IQR"))
}

if(!isGeneric("mad")){ 
    setGeneric("mad", function(x, center, constant, na.rm, low, high) standardGeneric("mad"))
}
###################################################################################
setMethod("var", signature(x = "UnivariateDistribution", y = "missing" ,na.rm  = "missing" ,use = "missing"),
    function(x, ...){
        m <- E(x, ...)  #  the mean
#        f <- ifelse(missing(fun), function(x)x, fun)
        return(E(x, function(x, mMean){(x - mMean)^2}, mMean = m, ...))
    })


setMethod("sd", signature(x = "UnivariateDistribution", na.rm  = "missing"), 
    function(x){
        return(sqrt(var(x)))
    })

setMethod("median", signature(x = "UnivariateDistribution", na.rm  = "missing"),
    function(x){
        return(q(x)(1/2))
    })

setMethod("mad", signature(x = "UnivariateDistribution", center  = "missing", 
                           constant  = "missing", na.rm  = "missing", 
                           low  = "missing", high  = "missing"),
    function(x){
        m <- median(x)
        y <- abs(x-m) 
        return(q(y)(1/2))
    })

setMethod("IQR", signature(x = "UnivariateDistribution", na.rm  = "missing"),
    function(x){
        return(q(x)(3/4)-q(x)(1/4))
    })

make01 <- function(x){
    if (!is(x, "UnivariateDistribution"))
        stop("This function is for distribution objects.")
    return((x-E(x))/sd(x))
    }
